#ifndef __RRFixPointLib_H__
#define __RRFixPointLib_H__



#include <stdint.h>



//--------------------------------------------------------------------------------------
//--- Basis-Fixpoint-Arithmetik-Routinen ------------------- Version vom 29.Dez.2007 ---
//--- Zulssiger Wertebereich ist -32767.0xx bis 32767.0xx -----------------------------
//--- Die Nachkommagenauigkeit betrgt lediglich 10 Bit! -------------------------------
//--- atofixpoint und fixpointtoa wandeln so gut sie knnen, aber nicht przise --------
//--- Also nicht vergessen: Die Rechenergebnisse sind reichlich UNGENAU ----------------
//--------------------------------------------------------------------------------------
//--- (c) 2007 Ralf Rosenkranz ---------------------------------------------------------
//--- voltax tt prima dott de ---------------------------------------------------------
//--- http://basic.3dc.de --------------------------------------------------------------
//--------------------------------------------------------------------------------------
//--- Die Routinen scheinen zu funktionieren aber ich garantiere fr nichts ------------
//--- Ich hafte fr keinerlei Schden und bernehme keine Gewhrleistung ---------------
//--- Dieser Quellcode darf nur fr *nichtkommerzielle* Zwecke frei verwendet werden ---
//--------------------------------------------------------------------------------------



typedef int32_t fixpoint;



fixpoint int16ToFixpoint (int16_t i);
int16_t fixpointToInt16 (fixpoint f);

fixpoint atofixpoint (char* str);
char* fixpointtoa (fixpoint f, char* str);

fixpoint fixpointAdd (fixpoint a, fixpoint b);
fixpoint fixpointSub (fixpoint a, fixpoint b);
fixpoint fixpointMult (fixpoint a, fixpoint b);
fixpoint fixpointDiv (fixpoint a, fixpoint b);
fixpoint fixpointSqr (fixpoint x);
fixpoint fixpointSqrt (fixpoint x);

#endif
